; ===============================================================================================================================
; ISN AutoIt Studio - Demo Plugin 2
; ===============================================================================================================================
; This is a Demonstaation plugin for the ISN AutoIt Studio. If installed and activated, you can run it via the "Tools" Menu in the ISN AutoIt Studio.
; It shows, that a plugin must not be bind as a tab in the studio. It can also be a native window application, but with ISN plugin connection!
; ===============================================================================================================================

;AutoIt Stuff
#NoTrayIcon
Opt("GUICloseOnESC", 0)
Opt("GUIOnEventMode", 1)

;Includes
#include <isnautoitstudio_plugin.au3>
#include <GUI.isf> ;Contains the whole GUI and Includes ($hGUI)

;The Plugin initialization
_ISNPlugin_initialize($hGUI)
If @error Then
	MsgBox(16, "Error", "This program is part of the ISN AutoIt Studio and cannot be started separately!")
	Exit ;Plugin can not start without the ISN
EndIf

;Show the GUI
GUISetState(@SW_SHOW, $hGUI)

; ===============================================================================================================================
; Executes the backup function in the ISN AutoIt Studio.
; ===============================================================================================================================
Func _ISN_backup_now()
	_ISNPlugin_Call_Async_Function_in_ISN_AutoIt_Studio("_Backup_Files")
EndFunc   ;==>_ISN_backup_now

; ===============================================================================================================================
; Shows/Hides the To-Do List in the ISN AutoIt Studio.
; ===============================================================================================================================
Func _ISN_Toggle_ToDo_List()
	_ISNPlugin_Call_Async_Function_in_ISN_AutoIt_Studio("_Toggle_ToDo_manager")
EndFunc   ;==>_ISN_Toggle_ToDo_List

; ===============================================================================================================================
; Opens the mainfile of the project in the ISN AutoIt Studio.
; ===============================================================================================================================
Func _ISN_open_Mainfile()
	$Mainfile = $ISN_AutoIt_Studio_opened_project_Path & "\" & IniRead($ISN_AutoIt_Studio_ISN_file_Path, "ISNAUTOITSTUDIO", "mainfile", "") ;Get the mainfile
	_ISNPlugin_Try_to_open_file_in_ISN_AutoIt_Studio($Mainfile) ;open the mainfile in the ISN
EndFunc   ;==>_ISN_open_Mainfile

; ===============================================================================================================================
; Shows the print preview of the currently opened file in the ISN AutoIt Studio.
; ===============================================================================================================================
Func _ISN_Print_current_file()
	_ISNPlugin_Call_Async_Function_in_ISN_AutoIt_Studio("_ISN_Print_current_file")
EndFunc   ;==>_ISN_Print_current_file

; ===============================================================================================================================
; Executes the "save" command on every tab in the ISN AutoIt Studio.
; ===============================================================================================================================
Func _ISN_Save_all_Tabs()
	_ISNPlugin_Call_Async_Function_in_ISN_AutoIt_Studio("_Save_All_tabs")
EndFunc   ;==>_ISN_Save_all_Tabs


; ===============================================================================================================================
; Display the currently selected text in an Scintilla Editor in a MessageBox.
; ===============================================================================================================================
Func _Display_MsgBox()
	Local $Scintilla_Handle = _ISNPlugin_Get_Scintilla_Handle_from_ISN_AutoIt_Studio($Get_last_used_Scintilla_Handle)
	Local $text = _ISNPlugin_Scintilla_Get_Selection_Text($Scintilla_Handle)
	MsgBox(262208, _ISNPlugin_Get_Langstring(12), $text, 0)
EndFunc   ;==>_Display_MsgBox

; ===============================================================================================================================
; Display the content of an au3 file in an dedicated code window.
; ===============================================================================================================================
Func _Display_au3_file_in_window()
	Local $filepath = FileOpenDialog(_ISNPlugin_Get_Langstring(4), $ISN_AutoIt_Studio_opened_project_Path, _ISNPlugin_Get_Langstring(11) & " (*.au3)", 3, "", $hgui)
	If @error Or $filepath = "" Then Return
	Local $text = FileRead($filepath)
	_ISNPlugin_Show_AutoIt_Code_Window($Code_Window_Show_Code_Only, _ISNPlugin_Get_Langstring(7), "", $text)
EndFunc   ;==>_Display_au3_file_in_window

; ===============================================================================================================================
; Exit the plugin
; ===============================================================================================================================
Func _Exit_Plugin()
	Exit
EndFunc   ;==>_Exit_Plugin

;While Loop
While 1
	Sleep(100)
WEnd
